Bug 832816 - Review Request: mckoi - Open Source Java SQL Database
Review Request: mckoi - Open Source Java SQL Database
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: jiri vanek
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-17 11:32 EDT by gil cattaneo
Modified: 2012-09-18 01:21 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-13 20:50:41 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jvanek: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
runLocalTest result.txt (48.50 KB, text/plain)
2012-07-16 18:16 EDT, gil cattaneo
no flags Details

  None (edit)
Description gil cattaneo 2012-06-17 11:32:29 EDT
Spec URL: http://gil.fedorapeople.org/mckoi.spec
SRPM URL: http://gil.fedorapeople.org/mckoi-1.0.4-1.fc16.src.rpm
Description: Mckoi SQL Database is an Open Source SQL Database System written in Java.
The Mckoi SQL Database project was started in 1998, and the goal was to
build a database management system in a traditional shared disk/shared memory
style architecture. Mckoi SQL Database includes some nice features such as
write-ahead-logging. Many of the design ideas implemented in this project
were carried through into MckoiDDB, the evolution of this project.
Fedora Account System Username: gil
Comment 1 jiri vanek 2012-07-11 05:16:52 EDT
rpmlints:

/var/lib/mock/fedora-17-x86_64/result/mckoi-1.0.4-1.fc17.src.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

/var/lib/mock/fedora-17-x86_64/result/mckoi-1.0.4-1.fc17.noarch.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

/var/lib/mock/fedora-17-x86_64/result/mckoi-javadoc-1.0.4-1.fc17.noarch.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

/var/lib/mock/fedora-17-x86_64/root/builddir/build/SPECS/mckoi.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.
Comment 2 jiri vanek 2012-07-11 05:52:31 EDT
MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.[1]
    MUST: The package must be named according to the Package Naming Guidelines .
    ok
    MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .
    ok
    MUST: The package must meet the Packaging Guidelines .
    ok
    MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
    ok
    MUST: The License field in the package spec file must match the actual license. [3]
    ok
    MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
    ok
    MUST: The spec file must be written in American English. [5]
    ok
    MUST: The spec file for the package MUST be legible. [6]
    ok
    MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    ok
    MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
    ok
    MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]
    ok
    MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
    ok
    MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
    ok
    MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
    ok
    MUST: Packages must NOT bundle copies of system libraries.[11]
    ok
    MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [12]
    ok
    MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]
    ok
    MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)[14]
    ok
    MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. [15]
    ok
    MUST: Each package must consistently use macros. [16]
    ok
    MUST: The package must contain code, or permissable content. [17]
    ok
    MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
    ok
    MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
    ok
    MUST: Static libraries must be in a -static package. [19]
    ok
    MUST: Development files must be in a -devel package. [20]
    ? *1
    MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release} [21]
    ok
    MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[19]
    ok
    MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [22]
    ok
    MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [23]
    ok
    MUST: All filenames in rpm packages must be valid UTF-8. [24]
    ok


SHOULD Items:
Items marked as SHOULD are things that the package (or reviewer) SHOULD do, but is not required to do.

    SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [25]
    ok
    SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [26]
    ? *2
    SHOULD: The reviewer should test that the package builds in mock. [27]
    ok
    SHOULD: The package should compile and build into binary rpms on all supported architectures. [28]
    ok
    SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
    install fine, but functionality not tested
    SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [29]
    ok
    SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [21]
    ok (for now)
    SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. [30]
    ok
    SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [31]
    ok
    SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.[32]
    not

1) There is no devel package, but imho it is pitty, but:  There are sources which should go to src package (usefull especially for java debugging java appliations), there are demos which probably deservs to be packed in demo package
2) italian transaltion worthy? O:)

the official review is fullfiled in this point, but I would like to ask several things:

a) The not existence of src and demo package is  inttional? (means *1) - imho it is more then worthy
b) contrib directory is not worthy to be packed?
c) test can not be run during build?
d) /./usr/share/java/MckoiSQLDB.jar is symlink to mckoi.jar. In that case I would recommand full version in mockoi-{version}.{release}.jar filename
e) in javadoc package ther is "bug" I do not understand -  /./usr/share/javadoc/mckoi/ contains javadoc and /./usr/share/doc/mckoi-javadoc-1.0.4/ contains licence. (also /./usr/share/doc/mckoi-1.0.4/ contains licence and readme for main package)
   imho /./usr/share/javadoc/mckoi/ should be symlink to /./usr/share/javadoc/mckoi-1.x.y/ which will then contains real javbadoc
f) there is directory doc in BUILD. It contains interesting information. IMHO they shoud go out in /./usr/share/doc/mckoi-1.0.4/ too (or whereevere you decide)
g) Isnt worthy some kinf of shell launcher to jar so anybody can connect easily to db? (but here I have lack of mckoi db knowledge)

Thanx for worthy package!
e
Comment 3 gil cattaneo 2012-07-16 17:54:58 EDT
what's means imho?

> a) The not existence of src and demo package is  inttional? (means *1) - imho it is more then worthy
yes
b) contrib directory is not worthy to be packed?
no unavailable deps package org.jboss.system
c) test can not be run during build?

> d) /./usr/share/java/MckoiSQLDB.jar is symlink to mckoi.jar. In that case I would recommand full version in mockoi-{version}.{release}.jar filename
not
can not do. see https://fedoraproject.org/wiki/Packaging:Java#Filenames

> e) in javadoc package ther is "bug" I do not understand -  /./usr/share/javadoc/mckoi/ contains javadoc and /./usr/share/doc/mckoi-javadoc-1.0.4/ contains licence. (also /./usr/share/doc/mckoi-1.0.4/ contains licence and readme for main package)
   imho /./usr/share/javadoc/mckoi/ should be symlink to /./usr/share/javadoc/mckoi-1.x.y/ which will then contains real javbadoc
see https://fedoraproject.org/wiki/Packaging:LicensingGuidelines#Subpackage_Licensing
and
https://fedoraproject.org/wiki/Packaging:Java#Javadoc_installation

> f) there is directory doc in BUILD. It contains interesting information. IMHO they shoud go out in /./usr/share/doc/mckoi-1.0.4/ too (or whereevere you decide)
yes if only mckoi is packaged as as db

> g) Isnt worthy some kinf of shell launcher to jar so anybody can connect easily to db? (but here I have lack of mckoi db knowledge)
mckoi is packaged as library and not as db, for now i haven't interest to add a launcher script
Comment 4 gil cattaneo 2012-07-16 18:13:21 EDT
> c) test can not be run during build?
test]$ sh ./testServerShutdown.sh

Mckoi SQL Database ( 1.0.4 )
Copyright (C) 2000 - 2011 Diehl and Associates, Inc.  All rights reserved.
Use: -h for help.

  Mckoi SQL Database comes with ABSOLUTELY NO WARRANTY.
  This is free software, and you are welcome to redistribute it
  under certain conditions.  See LICENSE.txt for details of the
  GPL License.

java.sql.SQLException: Connection refused
        at com.mckoi.database.jdbc.TCPStreamDatabaseInterface.connectToDatabase(TCPStreamDatabaseInterface.java:76)
        at com.mckoi.database.jdbc.MDriver.connect(MDriver.java:586)
        at java.sql.DriverManager.getConnection(DriverManager.java:579)
        at java.sql.DriverManager.getConnection(DriverManager.java:221)
        at com.mckoi.runtime.McKoiDBMain.doShutDown(McKoiDBMain.java:131)
        at com.mckoi.runtime.McKoiDBMain.main(McKoiDBMain.java:211)


test]$ sh ./runServerTest.sh
java.sql.SQLException: Connection refused
        at com.mckoi.database.jdbc.TCPStreamDatabaseInterface.connectToDatabase(TCPStreamDatabaseInterface.java:76)
        at com.mckoi.database.jdbc.MDriver.connect(MDriver.java:586)
        at java.sql.DriverManager.getConnection(DriverManager.java:579)
        at java.sql.DriverManager.getConnection(DriverManager.java:221)
        at com.mckoi.tools.JDBCScriptTool.main(JDBCScriptTool.java:257)
JDBCScriptTool [-jdbc JDBC_Driver_Class] [-url JDBC_URL] 
               -u username -p password 
               [-in Input_SQL_File] [-out Output_Result_File] 

  If -in or -out are not specified then the tool uses System.in 
  and System.out respectively.
Comment 5 gil cattaneo 2012-07-16 18:14:22 EDT
test]$ sh ./runLocalTest.sh
Script input from: script_in.txt
Script output to: result.txt
Comment 6 gil cattaneo 2012-07-16 18:16:13 EDT
Created attachment 598527 [details]
runLocalTest result.txt

runLocalTest result.txt
Comment 7 jiri vanek 2012-07-19 04:39:00 EDT
Thanx for clarifications!
imho - In My (Honest) Opinion ... sorry for confusion

Three concerns remains:

testing - I would recommend to run tests after build, and with grep somehow ensure that they passed. If you do not want to bother with this I will not insists, but it is good protection against pack something what is not working in case that your package will be inherited by someone else in some dark future.


>mckoi is packaged as library and not as db, for now i haven't interest to add a launcher script

Ah that is an pitty :(( But ok.

>> a) The not existence of src and demo package is  inttional? (means *1) - imho it is more then worthy
>yes

Hmm.. Why that? Demo package .. ok.. as yo wish, but source package for java package is extremely useful! Probably the best what you can do is jar all .java in src directory and provide it as src jar with similar version and linking as non src one (maybe you do not need to create separate package and just include in your current rpm.
What do you think?
Comment 8 gil cattaneo 2012-07-19 05:56:50 EDT
Spec URL: http://gil.fedorapeople.org/mckoi/1/mckoi.spec
SRPM URL: http://gil.fedorapeople.org/mckoi/1/mckoi-1.0.4-2.fc16.src.rpm
- Added demos package
Comment 9 jiri vanek 2012-07-19 08:08:54 EDT
**********
*APPROVED*
**********

Please mention in changelog and in demos %description that demos package contains also sources archive.

Thank you!
Comment 10 gil cattaneo 2012-07-20 08:06:30 EDT
New Package SCM Request
=======================
Package Name: mckoi
Short Description: Open Source Java SQL Database
Owners: gil
Branches: f17
InitialCC: java-sig
Comment 11 Gwyn Ciesla 2012-07-20 08:29:56 EDT
Git done (by process-git-requests).
Comment 12 Fedora Update System 2012-08-03 14:19:35 EDT
mckoi-1.0.4-2.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/mckoi-1.0.4-2.fc17
Comment 13 Fedora Update System 2012-08-05 17:23:21 EDT
mckoi-1.0.4-2.fc17 has been pushed to the Fedora 17 testing repository.
Comment 14 Fedora Update System 2012-08-13 20:50:41 EDT
mckoi-1.0.4-2.fc17 has been pushed to the Fedora 17 stable repository.

Note You need to log in before you can comment on or make changes to this bug.